'use strict';

var Model = require('../mvc/Model'),
  Util = require('../util/Util');

// Default values to be used by constructor
var _DEFAULTS = {
  component: '', // String - GMPE Name or "Total"
  data: [], // Array - Hazard contirbution bins
  //         Each bin has "m", "r", and "εdata" attributes
};

var _DEAGG_ID = 0;

/**
 * @param params {Object}
 *      Configuration options. See _DEFAULTS for more details.
 */
var Disaggregation = function (params) {
  var _this;

  params = Util.extend({}, _DEFAULTS, { id: 'deagg-' + _DEAGG_ID++ }, params);
  _this = Model(params);

  params = null;
  return _this;
};

module.exports = Disaggregation;
